require 'metasm'
require 'metasm/gui/gtk'

$VERBOSE = true

exe = Metasm::AutoExe.decode_file('../t207.exe')
dasm = exe.init_disassembler
dasm.parse_c_file '../t207.h'

# cache two very large and uninteresting visual studio internal functions
dasm.parse_c 'void blarg(int, int);'
dasm.function[0x401696] =
dasm.function[0x40167d] =
dasm.cpu.decode_c_function_prototype(dasm.c_parser, dasm.c_parser.toplevel.symbol['blarg'])

# dasm WinMain
entry = 0x401100

# do a few runs of the disassembler so that the graph view will show something
dasm.disassemble_mainiter [entry]
dasm.disassemble_mainiter

# launch GUI
w = Metasm::GtkGui::MainWindow.new.display(dasm)
# focus on entrypoint in graph mode
w.dasm_widget.focus_addr entry, 1
# use a custom big font
w.dasm_widget.views[1].set_font File.read('fontdesc')
w.signal_connect('destroy') { Gtk.main_quit }
Gtk.main
